DIM D(0 TO 100)
PRINT
SELECT CASE COMMAND$
  CASE "1"
    Port = &H3FE
  CASE "2"
    Port = &H2FE
  CASE "3"
    Port = &H3EE
  CASE "4"
    Port = &H2EE
  CASE ELSE
    SOUND 1000, 1
    PRINT "Usage: DCFTSR <ComPort>"
    PRINT
    PRINT "ComPort = 1-4"
    PRINT
    PRINT "Connect DCF-Interface to: Output 3@9 or 2@25, Input 1@9 oder 8@25 (COM)"
    PRINT
    SYSTEM
END SELECT
OUT Port - 3, 64
PRINT "Checking DCF Receiver ... ";
A = TIMER
DO
  IF TIMER - A > 2.5 THEN F = 1: EXIT DO
  IF INP(Port) > 127 THEN F = 0: EXIT DO
LOOP
IF F = 1 THEN
  OUT Port - 3, 0
  SOUND 1000, 1
  PRINT "Receiver not found!"
  PRINT
  SYSTEM
END IF
A = TIMER
DO
  IF TIMER - A > .5 THEN F = 1: EXIT DO
  IF INP(Port) < 128 THEN F = 0: EXIT DO
LOOP
IF F = 1 THEN
  OUT Port - 3, 0
  SOUND 1000, 1
  PRINT "Receiver not found!"
  PRINT
  SYSTEM
END IF
PRINT "OK."
PRINT "Waiting for end of minute ..."
C = 0
DO
  IF INP(Port) < 128 THEN
    A = TIMER
    WHILE INP(Port) < 128
      IF INKEY$ = CHR$(27) THEN
        SOUND 1000, 1
        PRINT
        PRINT "Aborted"
        PRINT
        OUT Port - 3, 0
        SYSTEM
      END IF
    WEND
    B = TIMER
    PRINT "x";
    C = C + 1
  END IF
  IF INKEY$ = CHR$(27) THEN
    SOUND 1000, 1
    PRINT
    PRINT "Aborted"
    PRINT
    OUT Port - 3, 0
    SYSTEM
  END IF
LOOP UNTIL (B - A > 1.3) OR (C > 59)
IF C > 59 THEN
  OUT Port - 3, 0
  SOUND 1000, 1
  PRINT
  PRINT "Error!"
  PRINT
  SYSTEM
END IF
PRINT
PRINT "Reading time information (takes 1 minute) ..."
C = -1
B = TIMER
DO
  IF INP(Port) > 127 THEN
    A = TIMER
    IF A - B > 1.3 THEN EXIT DO
    WHILE INP(Port) > 127
      IF INKEY$ = CHR$(27) THEN
        SOUND 1000, 1
        PRINT
        PRINT "Aborted"
        PRINT
        OUT Port - 3, 0
        SYSTEM
      END IF
    WEND
    B = TIMER
    C = C + 1
    D(C) = INT((B - A) * 6.666)
    PRINT RIGHT$(STR$(D(C)), 1);
  END IF
  IF INKEY$ = CHR$(27) THEN
    SOUND 1000, 1
    PRINT
    PRINT "Aborted"
    PRINT
    OUT Port - 3, 0
    SYSTEM
  END IF
LOOP
IF C = 58 THEN
  Min = (D(27) * 4 + D(26) * 2 + D(25)) * 10 + D(24) * 8 + D(23) * 4 + D(22) * 2 + D(21)
  Std = (D(34) * 2 + D(33)) * 10 + D(32) * 8 + D(31) * 4 + D(30) * 2 + D(29)
  ParMin = D(21) + D(22) + D(23) + D(24) + D(25) + D(26) + D(27)
  ParStd = D(29) + D(30) + D(31) + D(32) + D(33) + D(34)
  Tag = (D(41) * 2 + D(40)) * 10 + D(39) * 8 + D(38) * 4 + D(37) * 2 + D(36)
  Monat = D(49) * 10 + D(48) * 8 + D(47) * 4 + D(46) * 2 + D(45)
  Jahr = (D(57) * 8 + D(56) * 4 + D(55) * 2 + D(54)) * 10 + D(53) * 8 + D(52) * 4 + D(51) * 2 + D(50)
  ParDat = D(36) + D(37) + D(38) + D(39) + D(40) + D(41) + D(42) + D(43) + D(44) + D(45) + D(46) + D(47)
  ParDat = ParDat + D(48) + D(49) + D(50) + D(51) + D(52) + D(53) + D(54) + D(55) + D(56) + D(57)
  PRINT
  PRINT "Hours parity: ";
  IF ParStd MOD 2 = D(35) THEN
    PRINT "OK"
  ELSE
    SOUND 1000, 1
    PRINT "failed!"
    PRINT
    OUT Port - 3, 0
    SYSTEM
  END IF
  PRINT "Minutes parity: ";
  IF ParMin MOD 2 = D(28) THEN
    PRINT "OK"
  ELSE
    SOUND 1000, 1
    PRINT "failed!"
    PRINT
    OUT Port - 3, 0
    SYSTEM
  END IF
  TIME$ = RIGHT$(STR$(Std), LEN(STR$(Std)) - 1) + ":" + RIGHT$(STR$(Min), LEN(STR$(Min)) - 1) + ":00"
  PRINT "Time set to " + TIME$
  PRINT "Date parity: ";
  IF ParDat MOD 2 = D(58) THEN
    PRINT "OK"
  ELSE
    SOUND 1000, 1
    PRINT "failed!"
    PRINT
    OUT Port - 3, 0
    SYSTEM
  END IF
  IF Jahr < 10 THEN
    X$ = RIGHT$(STR$(Monat), LEN(STR$(Monat)) - 1) + "/" + RIGHT$(STR$(Tag), LEN(STR$(Tag)) - 1)
    DATE$ = X$ + "/200" + RIGHT$(STR$(Jahr), 1)
  ELSE
    X$ = RIGHT$(STR$(Monat), LEN(STR$(Monat)) - 1) + "/" + RIGHT$(STR$(Tag), LEN(STR$(Tag)) - 1)
    DATE$ = X$ + "/20" + RIGHT$(STR$(Jahr), 2)
  END IF
  PRINT "Date set to " + DATE$ + " (MM-DD-YYYY)"
ELSE
  SOUND 1000, 1
  PRINT "Wrong impulse count ("; C + 1; ")!"
  PRINT
  OUT Port - 3, 0
  SYSTEM
END IF
PRINT "No errors."
OUT Port - 3, 0
SYSTEM

SUB Ausgabe

END SUB

